    All Packages  Class Hierarchy  This Package  Previous  Next  Index

# Interface java.security.Certificate

public interface Certificate

This is an interface of abstract methods for managing an identity certificate. An identity certificate is a guarantee by a principal that a public key is that of another principal. (A principal represents an entity such as an individual user or a group.)

In particular, this interface is intended to be a common abstraction for constructs that have different formats but important common uses. For example, different types of certificates, such as X.509 certificates and PGP certificates, share general certificate functionality (the need to encode and decode certificates) and some types of information, such as a public key, the principal whose key it is, and the guarantor guaranteeing that the public key is that of the specified principal. So an implementation of X.509 certificates and an implementation of PGP certificates can both utilize the Certificate interface, even though their formats and additional types and amounts of information stored are different.

Important: This interface is useful for cataloging and grouping objects sharing certain common uses. It does not have any semantics of its own. In particular, a Certificate object does not make any statement as to the validity of the binding. It is the duty of the application implementing this interface to verify the certificate and satisfy itself of its validity.

##

decode(InputStream)
  Decodes a certificate from an input stream.
encode(OutputStream)
  Encodes the certificate to an output stream in a format that can be decoded by the `decode` method.
getFormat()
  Returns the name of the coding format.
getGuarantor()
  Returns the guarantor of the certificate, that is, the principal guaranteeing that the public key associated with this certificate is that of the principal associated with this certificate.
getPrincipal()
  Returns the principal of the principal-key pair being guaranteed by the guarantor.
getPublicKey()
  Returns the key of the principal-key pair being guaranteed by the guarantor.
toString(boolean)
  Returns a string that represents the contents of the certificate.

##

getGuarantor

     public abstract Principal getGuarantor()

  Returns the guarantor of the certificate, that is, the principal guaranteeing that the public key associated with this certificate is that of the principal associated with this certificate. For X.509 certificates, the guarantor will typically be a Certificate Authority (such as the United States Postal Service or Verisign, Inc.).

  Returns:
    the guarantor which guaranteed the principal-key binding.

getPrincipal

     public abstract Principal getPrincipal()

  Returns the principal of the principal-key pair being guaranteed by the guarantor.

  Returns:
    the principal to which this certificate is bound.

getPublicKey

     public abstract PublicKey getPublicKey()

  Returns the key of the principal-key pair being guaranteed by the guarantor.

  Returns:
    the public key that this certificate certifies belongs to a particular principal.

encode

     public abstract void encode(OutputStream stream) throws KeyException, IOException

  Encodes the certificate to an output stream in a format that can be decoded by the `decode` method.

  Parameters:
    stream - the output stream to which to encode the certificate.
  Throws: KeyException
    if the certificate is not properly initialized, or data is missing, etc.
  Throws: IOException
    if a stream exception occurs while trying to output the encoded certificate to the output stream.
  See Also:
    decode, getFormat

decode

     public abstract void decode(InputStream stream) throws KeyException, IOException

  Decodes a certificate from an input stream. The format should be that returned by `getFormat` and produced by `encode`.

  Parameters:
    stream - the input stream from which to fetch the data being decoded.
  Throws: KeyException
    if the certificate is not properly initialized, or data is missing, etc.
  Throws: IOException
    if an exception occurs while trying to input the encoded certificate from the input stream.
  See Also:
    encode, getFormat

getFormat

     public abstract String getFormat()

  Returns the name of the coding format. This is used as a hint to find an appropriate parser. It could be "X.509", "PGP", etc. This is the format produced and understood by the `encode` and `decode` methods.

  Returns:
    the name of the coding format.

toString

     public abstract String toString(boolean detailed)

  Returns a string that represents the contents of the certificate.

  Parameters:
    detailed - whether or not to give detailed information about the certificate.

    All Packages  Class Hierarchy  This Package  Previous  Next  Index

Submit a bug or feature - Version 1.1.8 of Java Platform API Specification
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1995-1999 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.